;Zi - The Flie Buster
;Fernando Mora (neverwinter_nights@hotmail.com)
;19/Ago/2002

	processor 6502
	include vcs.h
FLYES = $05

JOY0 = $80
PLYV0 = #JOY0 + 1
PLYH0 = #PLYV0 + 1
VLINE = #PLYH0 + 1
HLINE = #VLINE + 1
TEMP1 = #HLINE + 1
TEMP2 = #TEMP1 + 1
PTRSPRL = #TEMP2 + 1
PTRSPRH = #PTRSPRL + 1
PTRFLVLINE = #PTRSPRH + #FLYES + 1
SCORE1P0 = #PTRFLVLINE + 1
SCORE2P0 = #SCORE1P0 + 1
SCOREP1 = #SCORE2P0 + 1
PTRDI1GL = #SCOREP1 + 1
PTRDI1GH = #PTRDI1GL + 1
PTRDI2GL = #PTRDI1GH + 1
PTRDI2GH = #PTRDI2GL + 1
PTRDI3GL = #PTRDI2GH + 1
PTRDI3GH = #PTRDI3GL + 1
PTRDI4GL = #PTRDI3GH + 1
PTRDI4GH = #PTRDI4GL + 1
PLYHD0 = #PTRDI4GH + 1
PLYSTP0 = #PLYHD0 + 1

	org $F000
START

	SEI
	CLD
	LDX #$FF
	TXS
	LDA #$97
	STA SCORE1P0
	LDA #$42
	STA SCORE2P0
	STA SCOREP1

	LDA #100
	STA PLYV0

	LDA #0
	STA COLUBK
	LDA #$0E
	STA COLUPF
	LDA #$FE
	STA COLUP0
	LDA #$13
	STA COLUP1

	LDA #$01
	STA CTRLPF
	LDA #$03
	STA PLYH0

	LDA #$00
	STA PTRSPRL
	STA PTRDI1GL

	LDA #$FF
	STA PTRSPRH
	STA PTRDI1GH
	STA PTRDI2GH
	STA PTRDI3GH
	STA PTRDI4GH
	LDA #40
	STA PTRFLVLINE
	LDA #$F8
	STA PLYSTP0

MAIN
	LDA #0
	STA VLINE
	LDA #2
	STA VSYNC
	STA WSYNC
	STA WSYNC
	STA WSYNC
	LDA #0
	STA VSYNC

	LDA #43
	STA TIM64T		;Timer for Vertical Blank

	LDA SWCHA
	CMP #$FF
	BEQ NOMOVIMIENTOS

	ASL 
	BCS NEXT		;Check Right
;*************************************************
	STA TEMP1
	CLC
	LDA PLYSTP0
	AND #$0F
	SBC #$01
	AND #$0F
	STA PLYSTP0	
	TAX
	LDA ZIMOVS,X
	STA HMP0
	BCS GOGO1
	INC PLYH0
GOGO1
	LDA TEMP1
	ASL	
	JMP NEXT1
	
NEXT
	ASL
	BCS NEXT1		;Check Left
;*************************************************
	STA TEMP1
	CLC
	LDA PLYSTP0
	ORA #$F0
	ADC #$01
	AND #$0F
	STA PLYSTP0
	
	TAX
	LDA ZIMOVS,X
	STA HMP0
	BCC GOGO
	DEC PLYH0
GOGO
	LDA TEMP1
;*************************************************
;	LDX #$08
;	STX REFP0
NEXT1
	ASL
	BCS NEXT2		;Check Down
	DEC PLYV0
	JMP ENDWALK
NEXT2
	ASL 
	BCS ENDWALK		;Check Up
	INC PLYV0
ENDWALK
	LDA #$08
	ADC PTRSPRL
	AND #$18
	STA PTRSPRL

NOMOVIMIENTOS
	LDA INPT4    
	BMI GONOW

GONOW

VERTICALBLANK			;Wait for Vertical Blank to End
	LDA INTIM
	BNE VERTICALBLANK

	STA WSYNC
	STA VBLANK

;********************DRAW SCORE********************
	LDY #7
	STA WSYNC
CENTERSCORE
	DEY
	BPL CENTERSCORE	
	STA RESP0	
	STA RESP1
	STA WSYNC

	SED
	LDA SCORE2P0
	CLC
	ADC #$01
	STA SCORE2P0
	LDA #$00
	ADC SCORE1P0
	STA SCORE1P0
	CLD

	CLC
	LDA SCORE1P0
	AND #$0F
	ASL
	ASL
	ASL
	ADC #$40
	STA PTRDI2GL,0

	LDA SCORE1P0
	AND #$F0
	LSR
	ADC #$40
	STA PTRDI1GL,0

	LDA SCORE2P0
	AND #$0F
	ASL
	ASL
	ASL
	ADC #$40
	STA PTRDI4GL,0

	STA WSYNC

	LDA SCORE2P0
	AND #$F0
	LSR
	ADC #$40
	STA PTRDI3GL,0

	LDA #$01
	STA NUSIZ0
	STA NUSIZ1

	LDY #7
DRAWSCORE
	STA WSYNC
	LDA (PTRDI3GL),Y
	STA TEMP1
	LDA (PTRDI4GL),Y
	STA TEMP2
	LDA (PTRDI1GL),Y
	STA GRP0
	LDA (PTRDI2GL),Y
	STA GRP1
	NOP
	NOP
	NOP
	LDA TEMP1
	LDX TEMP2
	STA GRP0
	STX GRP1
	DEY
	BPL DRAWSCORE

	STA WSYNC
	LDA #$00
	STA GRP0
	STA GRP1
	STA VLINE
	STA NUSIZ0

	LDY #6
LOSTIME
	STA WSYNC
	DEY
	BPL LOSTIME
;********************DRAW SCREEN********************

	STA WSYNC
	LDY PLYH0
	STA WSYNC
CENTERPLAYER
	DEY
	BPL CENTERPLAYER
	STA RESP0
	STA WSYNC
	STA WSYNC
	STA WSYNC
	STA HMOVE

	LDY #7
	LDX #87


DRAWSCREEN
	STA WSYNC
	CPX #30			;0 + (2) = [2]
	BCS PLAYERGRAPHICS	;2 + (2) = [4]

	STX TEMP1		;4 + (4) = [8]
	TXA			;8 + (2) = [10]
	LSR			;10 + (2) = [12]
	TAX			;12 + (2) = [14]
	LDA ZiHomePF0,X		;14 + (4) = [18]
	STA PF0			;18 + (3) = [21]
	LDA ZiHomePF1,X		;21 + (4) = [25]
	STA PF1			;25 + (3) = [28]
	LDA ZiHomePF2,X		;28 + (4) = [32]
	STA PF2			;32 + (3) = [35]
	LDX TEMP1		;35 + (3) = [38]
	LDA #$00		;38 + (2) = [40]
	STA PF0			;40 + (3) = [43]
	STA PF1			;43 + (3) = [46]
	STA PF2			;46 + (3) = [49]
	NOP	
	NOP
	NOP
	NOP
	NOP
	NOP
	NOP
	NOP
	NOP
	NOP
	NOP
	NOP

PLAYERGRAPHICS
	STA WSYNC
	CPY #$00		;0 + (2) = [2]
	BMI NOTDRAWINGPLAYER	;2 + (2) = [4]	'Player already drawed
	
	CPX PLYV0		;4 + (3) = [7]	'Draw Player Now?
	BCS NOTDRAWINGPLAYER	;7 + (2) = [9]

	LDA (PTRSPRL),Y		;9 + (6) = [15]	'Read Data for player
	DEY			;15 + (2) = [17] 
	STA GRP0		;17 + (3) = [20]
	JMP ENDDRAW		;20 + (3) = [23]

NOTDRAWINGPLAYER
	LDA #$00		;23 + (2) = [25]
	STA GRP0		;25 + (3) = [28]

ENDDRAW
	DEX			;28 + (2) = [30]
	STA RESM0
	NOP			;Some ciclys, usefull after
	NOP			;
	NOP
	NOP
	NOP
	NOP	
	NOP
	NOP
	NOP
	NOP
	NOP
	NOP
	NOP
	NOP
	NOP
	NOP
	NOP
	NOP
	BNE DRAWSCREEN		
;********************DRAW SCREEN END********************

	LDA #2
	LDX #30
	STA WSYNC
	STA VBLANK

OVERSCAN
	STA WSYNC
	DEX	
	BNE OVERSCAN
	
	JMP MAIN

	org $FF00
ZI
; Zi - Frame 1
	.byte  %01101110
	.byte  %10010000
	.byte  %00010111
	.byte  %01111100
	.byte  %01111100
	.byte  %00010111
	.byte  %10010000
	.byte  %01101110
; Zi - Frame 2
	.byte  %01101110
	.byte  %01010000
	.byte  %00010111
	.byte  %01111100
	.byte  %01111100
	.byte  %00010111
	.byte  %10011000
	.byte  %01100111
; Zi - Frame 3
	.byte  %01100111
	.byte  %10011000
	.byte  %00010111
	.byte  %01111100
	.byte  %01111100
	.byte  %00010111
	.byte  %01010000
	.byte  %01101110
; Zi - Frame 4
	.byte  %01101110
	.byte  %10010000
	.byte  %00010111
	.byte  %01111100
	.byte  %01111100
	.byte  %00010111
	.byte  %10010000
	.byte  %01101110
Fly
; Fly - Frame 1
	.byte  %00111100
	.byte  %01111110
	.byte  %01111110
	.byte  %01111110
	.byte  %01111110
	.byte  %01111110
	.byte  %01111110
	.byte  %00111100
; Fly - Frame 2
	.byte  %00111100
	.byte  %01111110
	.byte  %01111110
	.byte  %01111110
	.byte  %01111110
	.byte  %01111110
	.byte  %01111110
	.byte  %00111100
; Fly - Frame 3
	.byte  %00111100
	.byte  %01111110
	.byte  %01111110
	.byte  %01111110
	.byte  %01111110
	.byte  %01111110
	.byte  %01111110
	.byte  %00111100
; Fly - Frame 4
	.byte  %00111100
	.byte  %01111110
	.byte  %01111110
	.byte  %01111110
	.byte  %01111110
	.byte  %01111110
	.byte  %01111110
	.byte  %00111100
DIGITS
; 0
	.byte  %11111100
	.byte  %11111100
	.byte  %10001100
	.byte  %10001100
	.byte  %10000100
	.byte  %10000100
	.byte  %11111100
	.byte  %11111100
; 1
	.byte  %01110000
	.byte  %01110000
	.byte  %01110000
	.byte  %01110000
	.byte  %01100000
	.byte  %01100000
	.byte  %01100000
	.byte  %01100000
; 2
	.byte  %11111100
	.byte  %11111100
	.byte  %11000000
	.byte  %11111100
	.byte  %11111100
	.byte  %00001100
	.byte  %11111100
	.byte  %11111100
; 3
	.byte  %11111100
	.byte  %11111100
	.byte  %00001100
	.byte  %01111100
	.byte  %01111100
	.byte  %00001100
	.byte  %11111100
	.byte  %11111100
; 4
	.byte  %00011000
	.byte  %00011000
	.byte  %00011000
	.byte  %11111100
	.byte  %11111100
	.byte  %11011000
	.byte  %11011000
	.byte  %11000000
; 5
	.byte  %11111100
	.byte  %11111100
	.byte  %00001100
	.byte  %11111100
	.byte  %11111100
	.byte  %11000000
	.byte  %11111100
	.byte  %11111100
; 6
	.byte  %11111100
	.byte  %11111100
	.byte  %11001100
	.byte  %11111100
	.byte  %11111100
	.byte  %11000000
	.byte  %11111100
	.byte  %11111100
; 7
	.byte  %11000000
	.byte  %11000000
	.byte  %01100000
	.byte  %00110000
	.byte  %00011000
	.byte  %00001100
	.byte  %11111100
	.byte  %11111100
; 8
	.byte  %11111100
	.byte  %11111100
	.byte  %11001100
	.byte  %11111100
	.byte  %11111100
	.byte  %11001100
	.byte  %11111100
	.byte  %11111100
; 9
	.byte  %11111100
	.byte  %11111100
	.byte  %00001100
	.byte  %11111100
	.byte  %11111100
	.byte  %11001100
	.byte  %11111100
	.byte  %11111100
ZiHomePF0
	.byte $00,$80,$40,$20,$90,$50, $00,$F0,$00,$00,$00,$E0,$10,$00,$F0
ZiHomePF1
	.byte $08,$88,$69,$1E,$23,$42,$8E,$90,$60,$40,$A1,$23,$16,$0C,$F8
ZiHomePF2
	.byte $09,$09,$08,$08,$08,$0F,$08,$04,$02,$01,$00,$00,$00,$00,$00
ZIMOVS
	.byte $80,$90,$A0,$B0,$C0,$D0,$E0,$F0,$00,$10,$20,$30,$40,$50,$60,$70

	org $FFFC
	.word START
	.word START